package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Grid;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Beam extends Entity {
		
		
		
		private var sprite:Image = new Image(Assets.BEAM_IMG);
		private var h:int;
		
		public function Beam(x:Number, y:Number, tileGrid:Grid) {
			this.x = x;
			this.y = y;
			graphic = sprite;
			h = calculateHeight(tileGrid);
			sprite.scaleY = h;
			setHitbox(10, h * GameWorld.TILE_SIZE);
			this.y -= (h - 1) * GameWorld.TILE_SIZE;
			layer = 1;
			type = "beam";
		}
		
		
		private function calculateHeight(grid:Grid):int {
			
			var y:int = Math.floor((this.y + 1) / GameWorld.TILE_SIZE);
			var x:int = Math.floor((this.x + 1) / GameWorld.TILE_SIZE);
			var sy:int = y;
			while (!grid.getTile(x, y) && y >= 0) {
				y -= 1;
			}
			
			return sy - y;
		}
		
		
		override public function update():void {
			super.update();
			
			
			if (Math.abs (x - FP.camera.x) < 1.5 * GameWorld.SCREEN_WIDTH 
				&& Math.abs (y - FP.camera.y) < 1.5 * GameWorld.SCREEN_HEIGHT) {
				// potentially on screen
				
				var n:int = 1;
				while (n > 0) {
					FP.world.add(new Particle(x + Math.random() * 10, y + Math.random() * h * 10, (Math.random() - 0.5) * 0.5, -Math.random() * 2, new Image(Assets.SPARKLE_SMALL_IMG), 30, 0, false, true, 0, 0.01, false));
					n--;
				}
			}
			
		}
		
	}

}