package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Bug extends Entity {
		
		private static const SPEED:Number = 1;
		
		private var sprite:Image = new Image(Assets.BUG_IMG);
		
		private var onGround:Boolean = false;
		private var vx:Number;
		private var vy:Number;
		private var dir:int;
		private var dead:Boolean;
		
		public function Bug(x:Number, y:Number) {
			this.x = x;
			this.y = y;
			this.vx = 0;
			this.vy = 0;
			this.dir = Math.random() < 0.5 ? 1: -1;
			this.dead = false;
			graphic = sprite;
			setHitbox(4, 3, 0, 0);
		}
		
		override public function update():void {
			super.update();
			
			
			if (Math.abs (x - FP.camera.x) < 1.5 * GameWorld.SCREEN_WIDTH 
				&& Math.abs (y - FP.camera.y) < 1.5 * GameWorld.SCREEN_HEIGHT) {
				// potentially on screen
				
				vy += GameWorld.GRAVITY;
				
				if (collide("solid", x, y + 1)) {
					if (vy > 0) vy = 0;
					onGround = true;
				} else {
					onGround = false;
				}
				
				
				if (!dead) {
					if (onGround) {
						if (Math.abs(GameWorld.theWorld.player.x - x) < 50
							&& Math.abs(GameWorld.theWorld.player.y - y) < 30 
							&& Math.random() < 0.03) {
							vx = -FP.sign(GameWorld.theWorld.player.x - x) * SPEED;
							dir = -FP.sign(GameWorld.theWorld.player.x - x);
						} else {
							vx = vx + (Math.random() - 0.4) * dir;
						}
					}
					if (vx > SPEED) vx = SPEED;
					if (vx < -SPEED) vx = -SPEED;
					
					if (collide("solid", x + dir, y)
						|| !collide("solid", x + dir*3, y+5)) {
						dir *= -1;
					}
					
					if (vx > 0) {
						sprite.flipped = false;
					} else if (vx < 0) {
						sprite.flipped = true;
					}
					
				} else {
					if (vx != 0 && collide("solid", x + dir, y)) {
						vx *= -1;
					}
				}
				
				if (collide("claw", x, y)) {
					dead = true;
					vx = GameWorld.theWorld.player.dir * 5;
					vy = -4;
				}
			}
			
			if (onGround) {
				vx *= 0.9;	
			}
			moveBy(vx, vy, "solid");
			
		}
		
	}

}