package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import net.flashpunk.Engine;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;

	/**
	 * ...
	 * @author D Kvarfordt
	 */
	[Frame(factoryClass = "Preloader")]
	[SWF(width = "640", height = "480")]
	
	public class Main extends Engine {
		
		private var introWorld:IntroWorld;
		private var gameWorld:GameWorld;
		private var player:Player;
		
		private var state:int;
		
		public function Main() {
			super(320, 240);
		}
		
		override public function init():void {
			super.init();
			
			FP.screen.scale = 2;
			
			Input.define("left", Key.LEFT);
			Input.define("right", Key.RIGHT);
			Input.define("attack", Key.X, Key.CONTROL, Key.DOWN);
			Input.define("jump", Key.UP, Key.Z, Key.SPACE, Key.SHIFT);
			
			//FP.console.enable();
			FP.console.toggleKey = Key.ENTER;
			
			state = 0;
			introWorld = new IntroWorld(this);
			FP.world = introWorld;
		}
		
		override public function update():void {
			super.update();
			
			if (state == 1 && player.dead) {
				respawn();
			}
		}
		
		public function next():void {
			state++;
			if (state == 1) {
				restart();
			}
		}
		
		private function respawn():void {
			gameWorld.respawnPlayer();
		}
		
		private function restart():void {
			player = new Player(0,0);
			gameWorld = new GameWorld(this, player);
			FP.world = gameWorld;
			Sounds.music.stop();
			Sounds.music.loop();
		}
		
	}

}