package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class MessagePopup extends Entity {
		
		private var dispTime:int;
		
		private var text:Text;
		private var state:int;
		private var dispTimer:int;
		
		public var finished:Boolean;
		
		public function MessagePopup(message:String, dispTime:int = 200) {
			text = new Text(message, 0, 0, { align:"center", wordWrap:true } );
			text.width = 320;
			text.height = 60;
			text.scrollX = 0;
			text.scrollY = 0;
			text.x = 0;
			text.y = 180;
			this.dispTime = dispTime;
			graphic = text;
			text.alpha = 0;
			state = 0;
			finished = false;
			layer = -1000;
		}
		
		override public function update():void {
			super.update();
			
			if (state == 0) {
				text.alpha += 0.05;
				if (text.alpha >= 1) {
					state = 1;
				}
			} else if (state == 1) {
				dispTime--;
				if (dispTime <= 0) {
					state = 2 ;
				}
			} else if (state == 2) {
				text.alpha -= 0.05;
				if (text.alpha <= 0) {
					FP.world.remove(this);
					finished = true;
				}
			}
		}
		
	}

}