package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Obstacle extends Entity {
		
		private var sprite:Image = new Image(Assets.OBSTACLE_IMG);
		
		private var health:int = 3;
		
		private var hurtBool:Boolean;
		
		public function Obstacle(x:Number, y:Number) {
			this.x = x;
			this.y = y;
			this.hurtBool = false;
			graphic = sprite;
			setHitbox(20, 20);
			
			type = "solid";
		}
		
		override public function update():void {
			super.update();
			
			if (!hurtBool && collide("claw", x, y)) {
				Sounds.wood.play();
				health--;
				hurtBool = true;
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
			}
			if (!collide("claw", x, y)) {
				hurtBool = false;
			}
			
			
			if (health <= 0) {
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 3, -Math.random() * 2, new Image(Assets.OBSTACLE_PARTICLE_IMG)));
				FP.world.remove(this);
			}
		}
		
	}

}