package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Orb extends Entity {
		
		private var sprite:Spritemap = new Spritemap(Assets.ORB_IMG, 20,20);
		
		private var vx:Number;
		private var vy:Number;
		
		public var touched:Boolean;
		
		public function Orb(x:Number, y:Number) {
			this.x = x;
			this.y = y;
			this.vx = 0;
			this.vy = 0;
			this.touched = false;
			
			sprite.add("glow", [0, 0, 0, 0, 0, 0, 1, 2, 3, 3, 2, 1], 5);
			sprite.add("shine", [4], 10);
			sprite.play("glow");
			
			graphic = sprite;
			
			setHitbox(20, 20);
		}
		
		override public function update():void {
			super.update();
			
			if (!touched && collide("player", x, y)) {
				touched = true;
				sprite.play("shine");
				Sounds.orb.play();
				GameWorld.theWorld.orbScreenEffect();
				
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				FP.world.add(new Particle(x+10, y+10, (Math.random() - 0.5) * 2, (Math.random() - 0.5) * 2, new Image(Assets.SPARKLE_SMALL_IMG),100, 0.0,false, false, 0, 0.07));
				
			}
			
			if (touched) {
				vy -= 0.01;
			}
			
			x += vx;
			y += vy;
			
			if (y < -100) {
				FP.world.remove(this);
			}
			
		}
		
	}

}