package  {
	import flash.display.Bitmap;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Rain extends Entity {
		
		private static var image:Bitmap = (new Assets.RAIN_IMG) as Bitmap;
		
		private var sprite:Image;
		
		private var xv:Number;
		private var yv:Number;
		private var colliding:Boolean;
		
		public function Rain(x:Number, y:Number, xv:Number) {
			this.x = x;
			this.y = y;
			this.xv = xv;
			this.yv = Math.random() + 8;
			this.sprite = new Image(Assets.RAIN_IMG); // potential memory hog
			this.colliding = false;
			sprite.originY = 80;
			sprite.angle = -Math.atan2(yv, xv) * 180 / Math.PI +90;
			
			/*if (Math.random() < 0.5) {
				sprite.scale = 0.5;
				yv *= 0.6;
				xv *= 0.6;
			}*/
			type = "rain";
			
			graphic = sprite;
			
			setHitbox(3, 3, 0, 0);
		}
		
		override public function update():void {
			super.update();
			
			x += xv;
			y += yv;
			
			if (y > FP.camera.y + GameWorld.SCREEN_HEIGHT + 80) {
				FP.world.remove(this);
			}
			if (x > FP.camera.x + GameWorld.SCREEN_WIDTH) {
				x -= GameWorld.SCREEN_WIDTH;
			} else if (x < FP.camera.x) {
				x += GameWorld.SCREEN_WIDTH;
			}
			
			if (collide("solid", x, y)) {
				if (!colliding) {
					if (true || Math.random() < 0.5) {
						FP.world.add(new Splash(x, y));
						FP.world.remove(this);
					} 
					colliding = true;
				}
			} else {
				colliding = false;
			}
		}
		
	}

}