package  {
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author D Kvarfordt
	 */
	public class Ray extends Entity {
		private var vx:Number;
		private var vy:Number;
		private var callbackPos:Function;
		private var callbackNeg:Function;
		private var target:Entity;
		
		public function Ray(x:Number, y:Number, target:Entity, callbackPos:Function, callbackNeg:Function) {
			this.x = x;
			this.y = y;
			this.callbackPos = callbackPos;
			this.callbackNeg = callbackNeg;
			this.target = target;
			
			
			setHitbox(10, 10, 5, 5);
		}
		
		override public function update():void {
			super.update();
			
			if (target == null) {
				FP.world.remove(this);
				return;
			}
			
			var dist:Number = FP.distance(x, y, target.x, target.y);
			
			vx = 10*(target.x - x) / dist;
			vy = 10*(target.y - y) / dist;
			
			moveBy(vx, vy, "solid");
			
			if (collide("solid", x + vx, y + vy)) {
				callbackNeg.call();
				FP.world.remove(this);
			}
			if (collide("player", x + vx, y + vy)) {
				callbackPos.call();
				FP.world.remove(this);
			}
			
		}
		
	}

}